new;
library pgraph;

cls;

loadm VL_FUND;
loadm VL_BENCHMARK;

loads NAME_FUND;
loads NAME_BENCHMARK;

/*
**> Test des dates
*/

d1 = VL_FUND[.,1];
d2 = VL_BENCHMARK[.,1];

if d1 /= d2;
  errorlog "error: dates do not match.";
endif;

indx = 1;
do until indx > rows(NAME_FUND);

  Name = NAME_FUND[indx];
  print "-------------------------------";
  print "Analyse du fonds "$+Name;
  VL = VL_Fund[.,indx+1];
  B = VL_BENCHMARK[.,2:4];

  Y = ln(VL) - lag1(ln(VL));
  X = ln(B) - lag1(ln(B));
  data = packr(Y~X);
  Y = data[.,1]; X = data[.,2:4];
  T = rows(Y);

  K = cols(X);
  A = ones(1,K);
  B = 1;
  C = 0;
  D = 0;
  bnds = zeros(K,1)~ones(K,1);

  XX = X'X;
  XY = X'Y;
  sv = ones(K,1)/K;
  {beta,u1,u2,u3,u4,retcode} = Qprog(sv,2*XX,2*XY,A,B,C,D,bnds);
  u = y - x*beta;
  rss = sumc(u .* u); 
  tss = sumc(y .* y);
  R2 = 1 - rss/tss;

  if R2 < 0.70;
    indx = indx + 1;
    continue;
  endif;

  print Name_BENCHMARK$~(""$+ftocv(beta,1,4));
  print "R2 = " R2;

  X = X[.,selif(1|2|3,beta .> 0.10)];

  X = ones(T,1)~X;
  XX = X'X;
  XY = X'Y;
  coeffs = invpd(XX)*XY;
  U = Y - X*coeffs;
  sigma = stdc(U);
  cov = sigma^2 * invpd(XX);
  stderr = sqrt(diag(cov));

  print "alpha = " coeffs[1];
  print "stderr = " stderr[1];

  indx = indx + 1;
endo;