/*
** Valorisation d'une option sur basket
**
*/

new;
library pgraph;

let S0 = 100 100 100 100;             
let vol = 0.25 0.30 0.25 0.40;         
T = 6/12;             
r = 0.05;

rndseed 123456;

ns = 50000;

let rho = 1.0
          0.5  1.0
          0.25 0.5  1.0
          0.10 0.25 0.5 1.0;
rho = xpnd(rho);

epsilon = chol(rho)'*rndn(4,ns);

WT = sqrt(T) * epsilon;
ST = S0 .* exp( (r-0.5*vol^2)*T + vol .* WT);
ST = ST';

PayOff = (ST[.,1] - ST[.,2] + ST[.,3] - ST[.,4]);          
PayOff = PayOff .* (PayOff .> 0);

Cs = exp(-r*T) * PayOff;

simul = seqa(1,1,ns);
stderr = stdc(Cs);
mcBS = cumsumc(Cs) ./ simul;
mcSTD = stderr ./ sqrt(simul);

graphset;
  _pdate = 0;                     /* Suppression de la date                     */
  _pframe = 0;                    /* Suppression du cadre                       */
  ytics(8,16,2,1);                /* Echelle de l'axes des Y                    */

  xy(simul,mcBS + (-1.96~0~1.96) .* mcSTD);




