new;

Maturity = 5;
Nominal = 1e6;

Lambda = 100/1e4;   // 100 bp
Margin_CDS = 80/1e4;    // 80 bp
RR = 0.40;

r = 0.03;           // Taux d'intrt
Ns = 1e5;           // Nombre de simulations

Tm = seqa(0.25,0.25,Maturity/0.25);       // Echeancier trimestriel
dTm = 0.25;

B0Tm = exp(-r*Tm);                           // B(t0,tm)

tau = -ln(rndu(1,Ns))/lambda;
JF = sumc(dTm .* B0Tm .* (Tm .<= tau));                       // Premium leg
tau = tau';
JV = (1-RR) .* exp(-r*tau) .* (tau .<= Maturity);             // Default leg

CDS = meanc(Nominal * Margin_CDS * JF) - meanc(Nominal .* JV);

print CDS;
print "Prix du CDS = " CDS "euros";

ATM = meanc(JV)/meanc(JF);
print "Spread du CDS = " 1e4*ATM "bp";

s = lambda*(1-RR);
print "Spread du CDS (formule approchee) = " 1e4*s "bp";


