new;
library pgraph;

Maturity = 5;

Lambda = 100|150|80|200;   
Lambda = lambda/1e4;
RR = 0.40;

r = 0.03;           // Taux d'intrt
Ns = 3e4;           // Nombre de simulations

Tm = seqa(0.25,0.25,Maturity/0.25);       // Echeancier trimestriel
dTm = 0.25;

B0Tm = exp(-r*Tm);                           // B(t0,tm)

rho = seqa(0,1/20,21);
F2D = zeros(rows(rho),1);
ATM = zeros(rows(rho),1);

N = rows(Lambda);

i = 1;
do until i > rows(rho);
  rndseed 123;
  if i == rows(rho);
    u = rndu(1,Ns) .* ones(N,1);
  else;
    u = cdfn(sqrt(rho[i])*rndn(1,Ns) + sqrt(1-rho[i])*rndn(N,Ns));
  endif;
  tau = -ln(1-u)./lambda;
  tmin = minc(tau);

  JF = sumc(dTm .* B0Tm .* (Tm .<= tmin'));                       // Premium leg
  JV = (1-RR) .* exp(-r*tmin) .* (tmin .<= Maturity);             // Default leg

  ATM[i] = meanc(JV)/meanc(JF);

  i = i + 1;
endo;

s = 1e4*lambda .* (1-RR);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  xlabel("Correlation de defaut");
  ylabel("Spread du F2D (en bp)");
  xtics(0,1,0.2,2);
  _pline = 1~6~0~maxc(s)~1~maxc(s)~1~12~10 |         // max(spread) <---> rho = 0%
           1~6~0~sumc(s)~1~sumc(s)~1~12~10 ;         // sum(spread) <---> rho = 100%
  xy(rho,1e4*ATM);


