/*
** Simulation de min(tau_1,...,tau_N) avec une dpendance correspondant  une copule gaussienne
** 
*/

new;
library pgraph;

rndseed 123;                           // Initialisation du gnrateur pseudo-alatoire

N = 5;
lambda = 200/1e4;
rho = 0.25;
rhoMatrix = diagrv(rho*ones(N,N),1);   // Matrice des corrlations canoniques

Ns = 1000;
u = cdfn(rndn(ns,n)*chol(rhoMatrix));         // Copule gaussienne

t = -ln(1-u)./lambda;                         /* 
                                              :: Simulation de la matrice Ns*N des
                                              :: temps de dfaut corrls
                                              */
                                              
tmin = minc(t');                              // Simulation de min(tau_1,...,tau_N)

graphset;
  _pnum = 2; _pdate = 0; _pframe = 0;
  xlabel("min(tau_1,...,tau_N)");
  call histp(tmin,25);



