/*
** Mise en vidence de la formule de Ble II
** 
*/

new;
library pgraph;

N = 100;                       // Nombre de firmes
EaD = 100;                      // EaD
muLGD = 0.5;                    // E[LGD]
sigmaLGD = 0.20;                // sigma[LGD]
PD = 0.2;                      // PD

EaD = EaD .* ones(N,1); muLGD = muLGD .* ones(N,1); 
sigmaLGD = sigmaLGD .* ones(N,1); PD = PD .* ones(N,1);

rho = 0.25;
alpha = seqa(0.01,0.01,99);

K = sumc(EAD .* muLGD .* cdfn( (cdfni(PD)-sqrt(rho).*cdfni(1-alpha'))./sqrt(1-rho) ));

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _pltype = 6; _pcolor = 9; _plwidth = 12;
  ylabel("Capital");
  xlabel("alpha");
  xy(alpha,K);  

Ns = 10000;

/*
** Simulation des dfauts corrls
*/

Z = sqrt(rho)*rndn(1,Ns) + sqrt(1-rho)*rndn(N,Ns);
D = (Z .<= cdfni(PD));

/*
** Simulation des LGD alatoires
*/

a = -muLGD + (muLGD^2) .* (1-muLGD) ./ (sigmaLGD^2);
b = a .* (1-muLGD)./muLGD;
rndLGD = rndBeta(N,Ns,a,b);

Loss = sumc(EaD .* rndLGD .* D);
Q = quantile(Loss,alpha);
    
graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _pltype = 6|3; _pcolor = 9|12; _plwidth = 10;
  xlabel("Perte");
  ylabel("CDF");
  xy(K~Q,alpha);      
  