/*
** Simulation du nombre de dfauts annuel
**
*/

new;
library pgraph;

rho = 0.2;

let lambda = 20 100 200;           /* lambda = 20 bp, 100 bp & 200 bp */
lambda = lambda / 1e4;
let nFirms = 200 400 150;          /* Composition du portefeuille     */

lambda = lambda[1]*ones(nFirms[1],1) |
         lambda[2]*ones(nFirms[2],1) |
         lambda[3]*ones(nFirms[3],1) ;

T = 1;                             /* Horizon = 1 an                  */
PD = 1 - exp(-lambda .* T);        /* Probabilits de dfaut          */

ns = 10000;
X = rndn(1,ns);
epsilon = rndn(sumc(nFirms),ns);
Z = sqrt(rho) * X + sqrt(1-rho) * epsilon;    /* Modle de Merton  un facteur */

D = cdfn(Z) .<= PD;                                 /* Indicatrices de dfaut        */
ND = sumc(D);                                       /* Nombre de dfauts en [0,T]    */

print "Nombre de dfauts moyens :     " meanc(ND);
print "Nombre de dfauts thoriques : " sumc(PD);   /* Ne dpend pas de la correl.   */

graphset;
  _pnum = 2;
  xlabel("Nombre de defauts annuel");
  call histp(ND,seqa(0,1,100));