/*
**> Simulation de pertes selon une distribution log-normale
**
*/

new;
library pgraph;

mu = 5;               /* Paramtres de la svrit */
sigma = 1.5;

Ns = 1000;

u = mu + sigma*rndn(Ns,1);     /* Simulations de va N(mu,sigma) */
Losses = exp(u);               /* Simulations de va LN(mu,sigma) */

moy_theorique = exp(mu +  0.5*sigma^2);
var_theorique = exp(2*mu +  sigma^2) * (exp(sigma^2) - 1.0);

moy_empirique = meanc(Losses);
var_empirique = stdc(Losses)^2;

print moy_theorique~moy_empirique;
print var_theorique~var_empirique;

graphset;
  call histp(Losses,25);

