/*
**> Estimation de la charge en capital
**
*/

new;
library pgraph;

rndseed 123;     

mu = 7;               /* Paramtres de la svrit */
sigma = 1.95;

lambda = 100;         /* Paramtre de la frquence */

Ns = 10000;           /* Nombre de simulations du Monte Carlo */

AgLosses = zeros(Ns,1);

i = 1;
do until i > Ns;
  Number_Losses = rndp(1,1,lambda);    /* Simulation du nombre de pertes annuelle */

  if Number_Losses == 0;
    i = i + 1;
    continue;
  endif;

  individual_Losses = exp( mu + sigma*rndn(Number_Losses,1) );
  AgLosses[i] = sumc(individual_Losses);

  i = i + 1;
endo;

moy_AgLosses = meanc(AgLosses);
moy_theorique = lambda * exp(mu + 0.5*sigma^2);
print moy_AgLosses|moy_theorique;

VaR = quantile(AgLosses,0.999);
EL = moy_theorique;
UL = VaR - EL;

CaR = VaR;
print "CaR (en millions d'euros) = " CaR/1e6;