/*
**> Estimation de la charge en capital aggrge
**
*/

new;
library pgraph;

rndseed 123;     

mu = 7 | 6;               /* Paramtres de la svrit */
sigma = 1.75 | 1.85;

lambda = 100 | 120;         /* Paramtre de la frquence */

Ns = 10000;           /* Nombre de simulations du Monte Carlo  */

AgLosses = zeros(Ns,2);

i = 1;
do until i > Ns;
  Number_Losses = rndp(2,1,lambda);    /* Simulation du nombre de pertes annuelle */

  if Number_Losses[1] /= 0;
    individual_Losses = exp( mu[1] + sigma[1]*rndn(Number_Losses[1],1) );
    AgLosses[i,1] = sumc(individual_Losses);
  endif;

  if Number_Losses[2] /= 0;
    individual_Losses = exp( mu[2] + sigma[2]*rndn(Number_Losses[2],1) );
    AgLosses[i,2] = sumc(individual_Losses);
  endif;

  i = i + 1;
endo;

CaR1 = quantile(AgLosses[.,1],0.999);
EL1 = lambda[1]*exp(mu[1]+0.5*sigma[1]^2);
UL1 = CaR1 - EL1;

CaR2 = quantile(AgLosses[.,2],0.999);
EL2 = lambda[2]*exp(mu[2]+0.5*sigma[2]^2);
UL2 = CaR2 - EL2;

CaR12 = CaR1 + CaR2;

/*
**> Si les types de risque sont indpendants
**
*/

TotLosses = AgLosses[.,1] + AgLosses[.,2];
CaR = quantile(TotLosses,0.999);

print "CaR1+2 = " CaR12/1e6;
print "CaR = " CaR/1e6;


/*
**> Approximation Gaussienne
**
*/

rho = 0.0;

CaRgauss = EL1 + EL2 + sqrt(UL1^2 + 2*rho*UL1*UL2 + UL2^2);
print "CaR Gaussienne = " CaRgauss/1e6;

