/*
** Simulation d'un vecteur gaussien corrl
**
** Cas d'une corrlation constante
*/

new;
cls;

rho = 0.3;        /* Valeur du coefficient de corrlation */
N = 10;           /* Dimension du vecteur alatoire       */

ns = 1000;

/*
:: mthode de dcomposition de Chosleky
*/

rhoMatrix = diagrv(rho*ones(N,N),1);
P = chol(rhoMatrix);           
U = rndn(ns,N);           
Z1 = U*P;                

/*
:: mthode factorielle
*/

X = rndn(ns,1);
Z2 = sqrt(rho) * X + sqrt(1-rho) * U;

print corrx(Z1);
print corrx(Z2); 

/*
:: Comparaison des temps de calcul
*/

for i(10,1000,10);
  N = i;

  rhoMatrix = diagrv(rho*ones(N,N),1);
  time_begin = hsec;
  Z1 = rndn(ns,N)*chol(rhoMatrix);                
  time_end = hsec;
  ct1 = (time_end - time_begin)/100;      /* Temps de calcul en secondes */

  time_begin = hsec;
  Z2 = sqrt(rho) * rndn(ns,1) + sqrt(1-rho) * rndn(ns,N);
  time_end = hsec;
  ct2 = (time_end - time_begin)/100;

  print /flush N~ct1~ct2~(ct1/miss(ct2,0));

endfor;





