new;

load Prices[251,3] = prix.dat;

let P0 = 244 135 315;
let theta = 2 -1 1;

VaR = gaussianVaR(Prices,P0,theta,0.99);
print VaR;

VaR = historicalVaR(Prices,P0,theta,0.99);
print VaR;

/*
**> gaussianVaR
**
*/

proc (1) = gaussianVaR(data,P0,theta,alpha);
  local r,mu,sigma,thetaStar,VaR;

  data = ln(data);
  r = packr(data - lag1(data));   
  mu = meanc(r);                  
  Sigma = vcx(r);                 

  thetaStar = theta .* P0;
  VaR = - thetaStar'mu + cdfni(alpha) * sqrt(thetaStar'Sigma*thetaStar);

  retp(VaR);
endp;

/*
**> historicalVaR
**
*/

proc (1) = historicalVaR(data,P0,theta,alpha);
  local r,thetaStar,PnL,VaR;

  data = ln(data);
  r = packr(data - lag1(data));
  thetaStar = theta .* P0;
  PnL = r*thetaStar;                    /* PnL = sumc(r' .* theta .* P0) */
  VaR = -quantile(PnL,1-alpha);

  retp(VaR);
endp;
