new;
library pgraph;

load Prices[251,3] = prix.dat;

let P0 = 244 135 315;
let theta = 2 -1 1;

data = ln(Prices);
r = packr(data - lag1(data));   

mu = meanc(r);                        // vecteur des moyennes
Sigma = vcx(r);                       // matrice de covariance

ns = 100000;                          // Nombre de simulations
rs = mu' + rndn(ns,3)*chol(Sigma);    // Rendements simuls

Ps = P0' .* (1+rs); 
PnL = Ps*theta - P0'theta;            // Simulation du PnL 

VaR = -quantile(PnL,0.01);
print ftos(VaR,"Monte-Carlo VaR(0.99) = %lf",5,2);
thetaStar = theta .* P0;
VaR = -thetaStar'mu + cdfni(0.99)*sqrt(thetaStar'*Sigma*thetaStar);
print ftos(VaR,"Theoretical VaR(0.99) = %lf",5,2);

graphset;
  _pdate = ""; _pframe = 0; _pnum = 2; 
  _pbartyp = 6~13;
  title("\214PnL");
  xlabel("\214variation (in euros)");
  ylabel("\214frequency (in %)");
  call histp(PnL,250);




