new;

proc EuropeanBS(S0,K,sigma,T,r);
  local w,d1,d2,P;

  w = sigma.*sqrt(T);
  d1 = ( ln(S0./K) + r.*T )./w + 0.5 * w;  
  d2 = d1 - w;

  P = S0.*cdfn(d1) - K.*exp(-r.*T).*cdfn(d2);
  retp(P);
endp;

load Prices[251,3] = prix.dat;
S = Prices[.,1];
rS = packr( ln(S) - lag1(ln(S)) );

load V[251,1] = vols.dat;
rV = packr( ln(V) - lag1(ln(V)) );

S_t = 244;

K = 250; tau = 1; ir = 0.05; sigma_t = 0.23;
C_t = EuropeanBS(S_t,K,sigma_t,tau,ir);

theta1 = -1; theta2 = 10;
P_t = theta1*S_t + theta2*C_t;

/*
**> un seul facteur de risque : S(t)
*/

S_tp1 = S_t .* (1+rS);
C_tp1 = EuropeanBS(S_tp1,K,sigma_t,tau-1/365,ir);
P_tp1 = theta1*S_tp1 + theta2*C_tp1;
PnL = P_tp1 - P_t; 

VaR = -quantile(PnL,0.01);
print VaR;

/*
**> deux facteurs de risque : S(t) et sigma(t)
*/

S_tp1 = S_t .* (1+rS);
sigma_tp1 = sigma_t .* (1+rV);
C_tp1 = EuropeanBS(S_tp1,K,sigma_tp1,tau-1/365,ir);
P_tp1 = theta1*S_tp1 + theta2*C_tp1;
PnL2 = P_tp1 - P_t; 

VaR = -quantile(PnL2,0.01);
print VaR;


